/*
//
// Copyright (C) 2006, 2007, 2008, 2009 Jean-Franois DEL NERO
//
// This file is part of HxCFloppyEmulator.
//
// HxCFloppyEmulator may be used and distributed without restriction provided
// that this copyright statement is not removed from the file and that any
// derivative work contains the original copyright notice and the associated
// disclaimer.
//
// HxCFloppyEmulator is free software; you can redistribute it
// and/or modify  it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// HxCFloppyEmulator is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with HxCFloppyEmulator; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
*/
///////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------//
//-------------------------------------------------------------------------------//
//-----------H----H--X----X-----CCCCC----22222----0000-----0000------11----------//
//----------H----H----X-X-----C--------------2---0----0---0----0--1--1-----------//
//---------HHHHHH-----X------C----------22222---0----0---0----0-----1------------//
//--------H----H----X--X----C----------2-------0----0---0----0-----1-------------//
//-------H----H---X-----X---CCCCC-----222222----0000-----0000----1111------------//
//-------------------------------------------------------------------------------//
//----------------------------------------------------- http://hxc2001.free.fr --//
///////////////////////////////////////////////////////////////////////////////////
// File : Dialog_RAWFileSettings.c
// Contains: Floppy Emulator Project
//
// Written by:	DEL NERO Jean Francois
//
// Change History (most recent first):
///////////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <commctrl.h>

#include <stdio.h>
#include <time.h>

#include <shlobj.h>

#include "resource.h"
#include "mainrouts.h"

#include "Dialog_CreateFileSystem.h"

#include "hxc_floppy_emulator.h"
#include "internal_floppy.h"
#include "floppy_loader.h"
#include "./usb_floppyemulator/usb_hxcfloppyemulator.h"

#include "../../common/plugins/amigadosfs_loader/amigadosfs_loader.h"
#include "../../common/plugins/fat12floppy_loader/fat12floppy_loader.h"


#include "fileselector.h"


extern HWINTERFACE * hwif;
extern guicontext * demo;
extern HXCFLOPPYEMULATOR * flopemu;
extern FLOPPY * thefloppydisk;

	typedef struct fs_type_
	{
		int id;
		char * name;

	}fs_type;

	enum
	{
		FS_720KB_ATARI_FAT12=0,
		FS_902KB_ATARI_FAT12,
		FS_880KB_AMIGADOS,
		FS_720KB_MSDOS_FAT12,
		FS_1_44MB_MSDOS_FAT12,
		FS_1_68MB_MSDOS_FAT12,
		FS_2_88MB_MSDOS_FAT12,
		FS_3_38MB_MSDOS_FAT12,
		FS_4_23MB_ATARI_FAT12,
		FS_6_78MB_MSDOS_FAT12
	};

	fs_type fs_type_list[]=
	{
		{ FS_720KB_ATARI_FAT12,"720KB Atari FAT12"},
		{ FS_902KB_ATARI_FAT12,"902KB Atari FAT12"},
		{ FS_880KB_AMIGADOS,"880KB AmigaDOS"},
		{ FS_720KB_MSDOS_FAT12,"720KB MS DOS FAT12"},
		{ FS_1_44MB_MSDOS_FAT12,"1.44MB MS DOS FAT12"},
		{ FS_1_68MB_MSDOS_FAT12,"1.68MB MS DOS FAT12"},
		{ FS_2_88MB_MSDOS_FAT12,"2.88MB MS DOS FAT12"},
		{ FS_3_38MB_MSDOS_FAT12,"3.38MB MS DOS FAT12 (HD)"},
		{ FS_4_23MB_ATARI_FAT12,"4.23MB Atari FAT12 (DD)"},
	//	{ FS_6_78MB_MSDOS_FAT12,"6.78MB MS DOS FAT12 (HD)"},
		{ -1,""}			
	};



////////////////////////////////////////////////////////////////////////// 
//
//  Gestion Boite de dialogue Settings
//  
//////////////////////////////////////////////////////////////////////////
BOOL CALLBACK DialogCreateFileSystem(
						  HWND  hwndDlg,	// handle of dialog box
						  UINT  message,	// message
						  WPARAM  wParam,	// first message parameter
						  LPARAM  lParam 	// second message parameter
						  )
{
	static char nbinstance=0;
	int wmId, wmEvent;
	int i,t,ret;
	BROWSEINFO binf;
	LPITEMIDLIST Item;
	char foldername[MAX_PATH];
	wmId    = LOWORD(wParam); 
	wmEvent = HIWORD(wParam); 



	switch (message) 
	{
		
	case WM_COMMAND:
		
		switch (wmEvent)
		{
		case BN_CLICKED:
			
			break;
			
		case EN_CHANGE: //-> appell a chaque modification d'une boite edit

			break;
		}

		switch (wmId)
		{
			
		case IDBUILDFS:
			i=0;
				memset(&binf,0,sizeof(BROWSEINFO));
				binf.hwndOwner=hwndDlg;
				binf.pszDisplayName="Select a source folder";
				binf.lpszTitle="Select the root directory of the floppy";
				binf.pszDisplayName=foldername;
				Item=SHBrowseForFolder(&binf);
				if(Item)
				{
					if(SHGetPathFromIDList(Item,foldername))
					{
						t=SendDlgItemMessage(hwndDlg, IDC_FSTYPE, CB_GETCURSEL, 0, 0);
						
						sprintf(demo->buffertext,"    Loading floppy   ");
						sprintf(demo->bufferfilename,"");	

						if(thefloppydisk)
						{
							floppy_unload(flopemu,thefloppydisk);
						}
						else
						{
							thefloppydisk=(FLOPPY *)malloc(sizeof(FLOPPY));
							memset(thefloppydisk,0,sizeof(FLOPPY));
						}

						switch(t)
						{
							case FS_720KB_ATARI_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fatst");
								break;

							case FS_902KB_ATARI_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fatst902");
								break;

							case FS_720KB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat720");
								break;

							case FS_1_44MB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat1440");
								break;
							case FS_1_68MB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat1680");
								break;
							case FS_2_88MB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat2880");
								break;
							case FS_3_38MB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat3381");
								break;

							case FS_4_23MB_ATARI_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fatmonsterst");
								break;

							case FS_6_78MB_MSDOS_FAT12:
								ret=FAT12FLOPPY_libLoad_DiskFile(flopemu,thefloppydisk,foldername,".fat6789");
								break;

							case FS_880KB_AMIGADOS:
								ret=AMIGADOSFSDK_libLoad_DiskFile(flopemu,thefloppydisk,foldername,0);
								break;

							default:
								ret=LOADER_UNSUPPORTEDFILE;
								break;								
						}

						if(ret!=LOADER_NOERROR)
						{
							switch(ret)
							{
								case LOADER_UNSUPPORTEDFILE:
									sprintf(demo->buffertext,"      Load error!\n\n\n\n    Image file not\n    yet supported!");
									break;
								case LOADER_FILECORRUPT:
									sprintf(demo->buffertext,"      Load error!\n\n\n\n   File corrupted ?\n    Read error ?");
									break;
								case LOADER_ACCESSERROR:
									sprintf(demo->buffertext,"      Load error!\n  Read file error!");
									break;
								default:
									sprintf(demo->buffertext,"      Load error!\n      error %d",ret);
									break;
							}
							free(thefloppydisk);
							thefloppydisk=0;

						}
						else
						{	
							InjectFloppyImg(flopemu,thefloppydisk,hwif);
							
							if(foldername)
							{
								i=strlen(foldername);
								while(i!=0 && foldername[i]!='\\')
								{
									i--;
								}
								if(foldername[i]=='\\') i++;
								sprintf(demo->bufferfilename,"%s",&foldername[i]);
							}
							else
							{
								sprintf(demo->bufferfilename,"Empty Floppy");
							}

							sprintf(demo->buffertext,"      Load ok!\n Track: %d\n Sector: %d\n Side: %d\n",thefloppydisk->floppyNumberOfTrack,thefloppydisk->floppySectorPerTrack,thefloppydisk->floppyNumberOfSide);
						}
						demo->loadstatus=ret;
					}
				}

				nbinstance=0;
				DestroyWindow(hwndDlg);
			break;
			
		case IDCANCELRAWFILE:
			nbinstance=0;
			DestroyWindow(hwndDlg);
			break;
			
	

		default:;
		}
				
		break;
		
	

		case WM_INITDIALOG:
			if(nbinstance!=0)
			{
				DestroyWindow(hwndDlg);
			}
			else
			{
				
				nbinstance=1;

				i=0;
				do
				{
					SendDlgItemMessage(hwndDlg,IDC_FSTYPE, CB_ADDSTRING, 0, (LPARAM)fs_type_list[i].name);
					i++;
				}while(fs_type_list[i].id!=-1);

				SendDlgItemMessage(hwndDlg, IDC_FSTYPE, CB_SETCURSEL,0, 0);		
			}
			break;
			
		case WM_CLOSE:
			nbinstance=0;
			DestroyWindow(hwndDlg);
			break;
			
		default:
			return FALSE;
			
	}
	
	return TRUE;
}

////////////////////////////////////////////////////////////////////////// 
////////////////////////////////////////////////////////////////////////// 
////////////////////////////////////////////////////////////////////////// 
////////////////////////////////////////////////////////////////////////// 
